#!/bin/bash
#
# Copyright (c) 2009, Intel Corporation.
#
# This Intel Cluster Ready program ("Software") is furnished under license and
# may only be used or copied in accordance with the terms of that license. No 
# license, express or implied, by estoppel or otherwise, to any intellectual 
# property rights is granted by this document. The Software is subject to 
# change without notice, and should not be construed as a commitment by Intel 
# Corporation to market, license, sell or support any product or technology. 
# Unless otherwise provided for in the license under which this Software is 
# provided, the Software is provided AS IS, with no warranties of any kind, 
# express or implied. Except as expressly permitted by the Software license, 
# neither Intel Corporation nor its suppliers assumes any responsibility or 
# liability for any errors or inaccuracies that may appear herein. Except as 
# expressly permitted by the Software license, no part of the Software may be 
# reproduced, stored in a retrieval system, transmitted in any form, or 
# distributed by any means without the express written consent of Intel
# Corporation.
#
#
# This script is intended to check required rolls for Intel(R) Cluster Ready installation
#


# Define colors
red='\033[31m'
green='\033[32m'
yellow='\033[33m'
blue='\033[34m'
pink='\033[35m'
cian='\033[36m'
white='\033[37m'

fail=0
status=""
rolls="base kernel web-server intel-icr intel-driver Red_Hat_Enterprise_Linux_Server_5.3"

for i in $rolls ; do
    echo -n "Checking $i..."
    status=$(rocks list roll $i | tail -n1 | awk '{print $4}')
    if [ "$status" != "yes" ]
    then
	fail=1
	echo -e "${red}Fail${white}"
    elif [ "$status" == "yes" ]
    then
	echo -e "${green}Ok${white}"
    else
	echo -e "${yellow}Unknow${white}"
    fi
done

if [ $fail == 1 ]
then
    echo "Required rolls are not present or are disable."
    exit 2
fi

exit 0