#!/bin/bash
#
# Copyright (c) 2009, Intel Corporation.
#
# This Intel Cluster Ready program ("Software") is furnished under license and
# may only be used or copied in accordance with the terms of that license. No 
# license, express or implied, by estoppel or otherwise, to any intellectual 
# property rights is granted by this document. The Software is subject to 
# change without notice, and should not be construed as a commitment by Intel 
# Corporation to market, license, sell or support any product or technology. 
# Unless otherwise provided for in the license under which this Software is 
# provided, the Software is provided AS IS, with no warranties of any kind, 
# express or implied. Except as expressly permitted by the Software license, 
# neither Intel Corporation nor its suppliers assumes any responsibility or 
# liability for any errors or inaccuracies that may appear herein. Except as 
# expressly permitted by the Software license, no part of the Software may be 
# reproduced, stored in a retrieval system, transmitted in any form, or 
# distributed by any means without the express written consent of Intel
# Corporation.
#
#
# This script is intended to run Intel(R) Cluster Checker in deployment mode
#

# Provisioning vars
PROVISION='rocks+'  ## change checking what prov is installed
PROV_VER='1.0'      ## once i have the prov find the version at know locations

# Script Version
VERSION='1.0'

# Error handling codes
ICR_UID=501 # have to be extracted by the installer script from the passwd file
E_FILENOTFOUND=4
E_WRONGARGS=65
SUCCESS=0

##################### Check that is a superuser #######################
#######################################################################
function user_check {
    if [ "$UID" -ne "$ICR_UID" ]
    then
	echo "Must be root to run this script"
	exit $E_NOTROOT
    fi
    return 0
}


##################### Change dir in a correct way #####################
#######################################################################
function cd_sec {
    cd $1
    if [ "$PWD" != "$1" ]
    then
	echo "Can't change to $1"
	exit $E_XCD
    fi
    return 0
}


### CONF FILE ###
if [ -z $CONF_BOARD ]
then 
    echo "The Intel Cluster Ready Config file was not generated"
    echo "Trying again after execute the './"$PROVISION"_install-v"$PROV_VER"'.sh --configure'"
    exit $E_FILENOTFOUND
fi
source $CONF_BOARD

export CLCK_LOG_DIRECTORY='/var/log/icr/'
cluster-check --deployment
