#!/bin/bash
#
# Copyright (c) 2009, Intel Corporation.
#
# This Intel Cluster Ready program ("Software") is furnished under license and
# may only be used or copied in accordance with the terms of that license. No 
# license, express or implied, by estoppel or otherwise, to any intellectual 
# property rights is granted by this document. The Software is subject to 
# change without notice, and should not be construed as a commitment by Intel 
# Corporation to market, license, sell or support any product or technology. 
# Unless otherwise provided for in the license under which this Software is 
# provided, the Software is provided AS IS, with no warranties of any kind, 
# express or implied. Except as expressly permitted by the Software license, 
# neither Intel Corporation nor its suppliers assumes any responsibility or 
# liability for any errors or inaccuracies that may appear herein. Except as 
# expressly permitted by the Software license, no part of the Software may be 
# reproduced, stored in a retrieval system, transmitted in any form, or 
# distributed by any means without the express written consent of Intel
# Corporation.
#
#
# This script calculate the next subnet available froma given one
#

ip_1=$(echo $1 | cut -d. -f1)
ip_2=$(echo $1 | cut -d. -f2)
ip_3=$(echo $1 | cut -d. -f3)
ip_4=$(echo $1 | cut -d. -f4)

nm_1=$(echo $2 | cut -d. -f1)
nm_2=$(echo $2 | cut -d. -f2)
nm_3=$(echo $2 | cut -d. -f3)
nm_4=$(echo $2 | cut -d. -f4)

ip_adrs=$1
nm_adrs=$2
sn_adrs=0

subnet_hop=0
aux=4
bad_mask=0
next=0

function subnet_calc {
    ip_1=$(echo $1 | cut -d. -f1)
    ip_2=$(echo $1 | cut -d. -f2)
    ip_3=$(echo $1 | cut -d. -f3)
    ip_4=$(echo $1 | cut -d. -f4)
    nm_1=$(echo $2 | cut -d. -f1)
    nm_2=$(echo $2 | cut -d. -f2)
    nm_3=$(echo $2 | cut -d. -f3)
    nm_4=$(echo $2 | cut -d. -f4)
    let sn_1="$ip_1&nm_1"
    let sn_2="$ip_2&nm_2"
    let sn_3="$ip_3&nm_3"
    let sn_4="$ip_4&nm_4"
    sn_adrs="$sn_1.$sn_2.$sn_3.$sn_4"
}

function check_nm {
    for j in "$nm_4" "$nm_3" "$nm_2" "$nm_1"
    do
	for i in 255 254 252 248 240 224 192 128 0
	do
	    if [ $j -eq $i ]
	    then
		let subnet_hop="256-$j"
		break
	    fi
	done
	if [ $subnet_hop -ne 0 ]
	then
	    if [ $subnet_hop -eq 256 ] 
	    then
		let subnet_hop="0"
	    else
		next=$aux
		break
	    fi
	else
	    next=$aux
	    bad_mask=1
	    break
	fi
	let aux="$aux-1"
    done
}

subnet_calc $ip_adrs $nm_adrs
check_nm

if [ $bad_mask -eq 1 ]
then
    echo "Bad netmask" #fail output
    exit 1
else
    octet=$(echo $sn_adrs | cut -d. -f$next)
    next_sn=0
    while [ $octet -ge $next_sn ]
    do
	let next_sn="$subnet_hop+$next_sn"
	if [ $next_sn -ge 256 ]
	then
	    if [ $next -eq 4 ]
	    then
		sn_adrs="$sn_1.$sn_2.$sn_3.0"
	    elif [ $next -eq 3 ]
	    then
		sn_adrs="$sn_1.$sn_2.0.$sn_4"
	    elif [ $next -eq 2 ]
	    then
		sn_adrs="$sn_1.0.$sn_3.$sn_4"
	    elif [ $next -eq 1 ]
	    then
		echo "There is no next eth0-based-subnet available. Please specify one manually"
	    else
		echo "Unexpected error trying to calculate subnet address" #should not happen
		exit 1
	    fi
	    let next="$next-1"
	    octet=$(echo $sn_adrs | cut -d. -f$next)
	    subnet_hop=1
	    next_sn=0
	fi
    done
    case "$next" in
	1)
	    ip_to_assign=$next_sn
	    ip_to_assign=$ip_to_assign$(echo $sn_adrs | awk -F. '{print "."$2"."$3"."$4+1}')
	    ;;
	2)
	    ip_to_assign=$(echo $sn_adrs | awk -F. '{print $1"."}')
	    ip_to_assign=$ip_to_assign$next_sn
	    ip_to_assign=$ip_to_assign$(echo $sn_adrs | awk -F. '{print "."$3"."$4+1}')
	    ;;
	3)
	    ip_to_assign=$(echo $sn_adrs | awk -F. '{print $1"."$2"."}')
	    ip_to_assign=$ip_to_assign$next_sn
	    ip_to_assign=$ip_to_assign$(echo $sn_adrs | awk -F. '{print "."$4+1}')
	    ;;
	4)
	    let next_sn="$next_sn+1"
	    ip_to_assign=$(echo $sn_adrs | awk -F. '{print $1"."$2"."$3"."}')
	    ip_to_assign=$ip_to_assign$next_sn
	    ;;
    esac
	#subnet_calc $ip_to_assign $nm_adrs
	#sed -i -e "s/IB0_IP=/IB0_IP=$ip_to_assign/" $CONF_FILE
	#sed -i -e "s/IB0_NM=/IB0_NM=$nm_adrs/" $CONF_FILE
	#sed -i -e "s/IB0_SN=/IB0_SN=$sn_adrs/" $CONF_FILE
    echo $ip_to_assign
fi

